using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

using iTextSharp;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.text.factories;
 
using System.IO;
using System.Collections;
using System.Windows.Forms;
/*1
using PdfSharp.Drawing;
using PdfSharp.Pdf;
using PdfSharp.Pdf.IO;
using PdfSharp.Pdf.Advanced;
using PdfSharp.Pdf.Security;
*/

namespace FreePDFMetadataEditor
{
    class MetadataHelper
    {
        //PdfEncryptor.Encrypt(reader,myFileStream,PdfWriter.ENCRYPTION_RC4_128,sU 
        //Password,"test",PdfWriter.AllowPrinting|PdfWriter.AllowCopy); 

        public static string Title = "";
        public static string Author = "";
        public static string Subject = "";
        public static string Keywords = "";

        public static DateTime CreationDate = DateTime.Now;
        public static DateTime ModificationDate = DateTime.Now;
        public static string Creator = "";

        public static bool SetDocInfo = false;

        public static bool CANCELLED = false;

        private static string DefaultPassword = "";

        public static string SetMetadataMultiplePDF(DataTable dt)
        {
            string err = "";
            CANCELLED = false;

            for (int k = 0; k < dt.Rows.Count; k++)
            {
                if (CANCELLED)
                {
                    return err;
                }

                string outfilepath="";
                string filepath=dt.Rows[k]["fullfilepath"].ToString();
                string password = dt.Rows[k]["userpassword"].ToString();

                if (frmMain.Instance.cmbOutputDir.Text.Trim() == TranslateHelper.Translate("Same Folder of PDF Document"))
                {
                    string dirpath = System.IO.Path.GetDirectoryName(filepath);
                    outfilepath = System.IO.Path.Combine(dirpath, System.IO.Path.GetFileNameWithoutExtension(filepath) + "_with_metadata.pdf");
                }
                else if (frmMain.Instance.cmbOutputDir.Text.ToString().StartsWith(TranslateHelper.Translate("Subfolder") + " : "))
                {
                    int subfolderspos = (TranslateHelper.Translate("Subfolder") + " : ").Length;
                    string subfolder = frmMain.Instance.cmbOutputDir.Text.ToString().Substring(subfolderspos);

                    outfilepath = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(filepath) + "\\" + subfolder, System.IO.Path.GetFileName(filepath));
                }
                else if (frmMain.Instance.cmbOutputDir.Text.Trim() == TranslateHelper.Translate("Overwrite PDF Document"))
                {
                    outfilepath = filepath;
                }
                else
                {
                    outfilepath = System.IO.Path.Combine(frmMain.Instance.cmbOutputDir.Text, System.IO.Path.GetFileName(filepath));
                }                                                

                try
                {
                    err += SetMetadataSinglePDF(filepath, outfilepath,password);
                }
                catch (Exception ex)
                {
                    err += ex.Message + "\r\n";
                }
            }

            return err;
        }
                
        public static string SetMetadataSinglePDF(string InputFile, string OutputFile,string Password)
        {
            string err = "";

            try
            {
                //                using (FileStream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                //{
                PdfReader reader = null;

                if (!System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(OutputFile)))
                {
                    try
                    {
                        System.IO.Directory.CreateDirectory(System.IO.Path.GetDirectoryName(OutputFile));
                    }
                    catch (Exception exd)
                    {
                        err += TranslateHelper.Translate("Error. Could not Create Directory for File") + " : " + InputFile+"\r\n"+exd.Message+"\r\n";
                        return err;
                    }
                }


                try
                {
                    //  reader = new PdfReader(input);

                    while (true)
                    {
                        using (Stream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                        {
                            try
                            {
                                if (!String.IsNullOrEmpty(Password))
                                {
                                    reader = new PdfReader(input, Encoding.Default.GetBytes(Password));
                                    //reader = new PdfReader(input, Encoding.UTF8.GetBytes(Password));

                                }
                                else
                                {
                                    reader = new PdfReader(input);
                                }

                                break;
                            }
                            catch (iTextSharp.text.pdf.BadPasswordException ex)
                            {
                                if (reader != null)
                                {
                                    reader.Close();
                                }

                                if (input != null)
                                {
                                    input.Close();
                                }

                                //frmMain.Instance.backgroundWorker1.CancelAsync();

                                //while (frmMain.Instance.backgroundWorker1.IsBusy)
                                //{
                                //Application.DoEvents();
                                //}

                                if (string.IsNullOrEmpty(Password) && !string.IsNullOrEmpty(DefaultPassword))
                                {
                                    Password = DefaultPassword;
                                }
                                else
                                {
                                    frmProgress.Instance.HideForm();

                                    Module.ShowMessage("Please enter the correct User Password !");

                                    frmPassword f2 = new frmPassword(InputFile);

                                    

                                    DialogResult dres = f2.ShowDialog();

                                    frmProgress.Instance.ShowForm();

                                    //frmMain.Instance.backgroundWorker1.RunWorkerAsync();

                                    if (dres == DialogResult.OK)
                                    {
                                        Password = f2.txtPassword.Text;

                                        if (f2.chkPassword.Checked)
                                        {
                                            DefaultPassword = Password;
                                        }

                                    }
                                    else
                                    {
                                        err += TranslateHelper.Translate("Error. Wrong User Password for File") + " : " + InputFile;
                                        return err;
                                    }
                                }
                            }
                        }
                    }                                        

                    Dictionary<string, string> dict = new Dictionary<string, string>();
                    //PdfDictionary dict = new PdfDictionary();

                    if (frmMain.Instance.chkAuthor.Checked)
                    {
                        dict.Add("Author", frmMain.Instance.txtAuthor.Text);
                    }
                    if (frmMain.Instance.chkCreator.Checked)
                    {
                        dict.Add("Creator", frmMain.Instance.txtCreator.Text);
                    }
                    if (frmMain.Instance.chkKeywords.Checked)
                    {
                        dict.Add("Keywords", frmMain.Instance.txtKeywords.Text);
                    }

                    if (frmMain.Instance.chkModificationDate.Checked)
                    {
                        //dict.Add("ModificationDate", ModificationDate.ToString());
                        //dict.Add("ModDate", new PdfDate(ModificationDate).ToString());
                        dict.Add(PdfName.MODDATE.ToString(), new PdfDate(frmMain.Instance.dpModificationDate.Value).ToString());
                    }

                    if (frmMain.Instance.chkCreationDate.Checked)
                    {
                        dict.Add("CreationDate", new PdfDate(frmMain.Instance.dpCreationDate.Value).ToString());
                    }

                    if (frmMain.Instance.chkTitle.Checked)
                    {
                        dict.Add("Title", frmMain.Instance.txtTitle.Text);
                    }

                    if (frmMain.Instance.chkSubject.Checked)
                    {
                        dict.Add("Subject", frmMain.Instance.txtSubject.Text);
                    }

                    DateTime curdate = DateTime.Now;

                    for (int m = 0; m < frmMain.Instance.dtcustom.Rows.Count; m++)
                    {
                        if (frmMain.Instance.dtcustom.Rows[m]["customname"].ToString().Trim() != string.Empty)
                        {
                            string filename=System.IO.Path.GetFileName(InputFile);
                            string filnoext=System.IO.Path.GetFileNameWithoutExtension(InputFile);
                            string directoryname=System.IO.Path.GetFileName(System.IO.Path.GetDirectoryName(InputFile));
                            string fullfilepath=InputFile;
                            string directorypath=System.IO.Path.GetDirectoryName(InputFile);

                            FileInfo fi=new FileInfo(InputFile);

                            string custval=frmMain.Instance.dtcustom.Rows[m]["customvalue"].ToString();
                            custval=custval.Replace("{SEC}",curdate.Second.ToString("D2"))
                            .Replace("{MIN}",curdate.Minute.ToString("D2"))
                            .Replace("{HOUR}",curdate.Hour.ToString("D2"))
                            .Replace("{YEAR}",curdate.Year.ToString("D4"))
                            .Replace("{MONTH}",curdate.Month.ToString("D2"))
                            .Replace("{DAY}",curdate.Day.ToString("D2"))
                            .Replace("{CURRENT DATETIME}",curdate.ToString())
                            .Replace("{CURRENT TIME}",curdate.ToShortTimeString())
                            .Replace("{CURRENT DATE}",curdate.ToShortDateString())
                            .Replace("{LAST ACCESS TIME}",fi.LastAccessTime.ToString())
                            .Replace("{CREATION TIME}",fi.CreationTime.ToString())
                            .Replace("{LAST WRITE TIME}",fi.LastWriteTime.ToString())
                            .Replace("{DIRECTORY PATH}",directorypath)
                            .Replace("{DIRECTORY NAME}",directoryname)
                            .Replace("{FULLFILEPATH}",fullfilepath)
                            .Replace("{FILENAME WITHOUT EXTENSION}",filnoext)
                            .Replace("{FILENAME}",filename);

                            while (true)
                            {
                                int spos = custval.IndexOf("{CUSTOM DATE:");
                                if (spos >= 0)
                                {
                                    int spos2 = spos + "{CUSTOM DATE:".Length;
                                    int epos = custval.IndexOf("}", spos2);

                                    string custdate = custval.Substring(spos2, epos - spos2);

                                    string custend = "";

                                    if (epos < custval.Length - 1)
                                    {
                                        custend = custval.Substring(epos, custval.Length - epos);
                                    }

                                    custval = custval.Substring(0, spos) + curdate.ToString(custdate) + custend;

                                }
                                else
                                {
                                    break;
                                }
                            }
                            
                            dict.Add(frmMain.Instance.dtcustom.Rows[m]["customname"].ToString(), custval);
                        }
                    }

                    string TmpFile = "";

                    if (frmMain.Instance.cmbOutputDir.Text == TranslateHelper.Translate("Overwrite PDF Document"))
                    {
                        TmpFile = OutputFile;
                        OutputFile = System.IO.Path.GetTempFileName();
                    }
                    
                    
                        using (MemoryStream memoryStream = new MemoryStream())
                        {
                            PdfStamper stamper = new PdfStamper(reader, memoryStream);
                            if (dict.Count > 0)
                            {
                                stamper.MoreInfo = dict;
                            }

                            stamper.Close();
                            reader.Close();

                            File.WriteAllBytes(OutputFile, memoryStream.ToArray());
                        }

                        if (TmpFile != string.Empty)
                        {
                            if (frmMain.Instance.chkKeepBackup.Checked)
                            {
                                string bakfilepath = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(TmpFile),
                                System.IO.Path.GetFileNameWithoutExtension(TmpFile) + ".bak.pdf");

                                System.IO.File.Move(TmpFile, bakfilepath);
                            }
                            else
                            {
                                System.IO.File.Delete(TmpFile);
                            }
                            System.IO.File.Move(OutputFile, TmpFile);
                        }

                        return err;                                                       
                }
                catch (Exception exm)
                {
                    err += TranslateHelper.Translate("An error occured while protecting PDF File") + " : " + InputFile + "\r\n" + exm.Message + "\r\n";
                }
                finally
                {
                    if (reader != null)
                    {
                        reader.Close();
                    }
                }
            }
            catch (Exception ex)
            {
                err += TranslateHelper.Translate("An error occured while protecting PDF File") + " : " + InputFile + "\r\n" + ex.Message + "\r\n";
            }

            return err;
        }
    }
}
